/******************************************************************************
 *   "$Id:  $"
 *
 *                 Copyright (c) 2002  O'ksi'D
 *
 *                      All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *      Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *
 *      Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 *
 *      Neither the name of O'ksi'D nor the names of its contributors
 *      may be used to endorse or promote products derived from this software
 *      without specific prior written permission.
 *
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER 
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *   Author : Jean-Marc Lienher ( http://oksid.ch )
 *
 ******************************************************************************/


#ifndef Xd6HtmlToRtf_h
#define Xd6HtmlToRtf_h

#include <FL/Fl_Widget.H>
#include <FL/Fl_Output.H>
#include <FL/x.H>
#include "Xd6HtmlBlock.h"
#include "Xd6HtmlFrame.h"
#include "Xd6XmlTree.h"
#include "Xd6ConfigFile.h"
#include <stdio.h>
#include <string.h>


class Xd6HtmlToRtf {
public:
	Xd6HtmlFrame *frame;

	char **open_tags;
	char **close_tags;
	int nb_tags;
	

	FILE *fp;
	Xd6XmlStl *lstyle;
	Xd6HtmlBlock *lb;
	int tab_nb;

	Xd6HtmlToRtf(Xd6HtmlFrame *f);

	static void header(FILE *fp);
	void to_rtf(const char *name);
	void to_rtf_cb(Xd6HtmlBlock *b, Xd6HtmlLine *l, Xd6HtmlSegment *s,
        	char *c, int len);
	static void scan_to_rtf_cb(Xd6HtmlBlock *b, Xd6HtmlLine *l, 
        	Xd6HtmlSegment *s, char *c, int len , void *d);
	void block_to_rtf(FILE *fp, Xd6HtmlBlock *b, Xd6HtmlBlock *lb);
	void seg_to_rtf(FILE *fp, Xd6HtmlSegment *s, Xd6XmlStl *style);
	static void text_to_rtf(FILE *fp, char *txt, int len, int nonbsp = 0);
	void push_tag(FILE *fp, char *otag, char *ctag);
	void pop_tag(FILE *fp, char *ctag);
	void pop_all_tags(FILE *fp);
};

#endif

/*
 * "$Id: $"
 */
